var App = require('dealers/App');
var Router = require('Router');
module.exports = {
    navigateWithClick: function (e) {
        var href = e.target.attributes.getNamedItem('href');
        if (href && href.value === '#') {
            e.preventDefault();
        }
        var route = this.route(e);
        if (route && this.routeIsDifferentPage(route) && Router.routeIsSuitableTargetForClientNavigation(route) && this.eventIsPlainOldClick(e)) {
            e.preventDefault();
            this.world().performAction(App.Navigate(route));
        }
    },
    eventIsPlainOldClick: function (e) {
        return e.button === 0 && !e.metaKey && !e.ctrlKey && !e.shiftKey && !e.altKey;
    },
    eventSourceIsReact: function (e) {
        return e.target.getAttribute('data-reactid') !== null;
    },
    routeIsDifferentPage: function (route) {
        var current = Router.routeForWorld(this.world());
        return !route.equals(current);
    }
};
