'use strict';
var React = require('react');
var _ = require('underscore');
var ImageUploader = React.createClass({
    propTypes: {
        name: React.PropTypes.string.isRequired,
        existingImage: React.PropTypes.string,
        defaultImage: React.PropTypes.string,
        onChange: React.PropTypes.func.isRequired
    },
    getDefaultProps: function () {
        return { defaultImage: '/images/org/noLogo-m.gif' };
    },
    _urlForState: function (nextProps) {
        var props = nextProps || this.props;
        return props.existingImage || props.defaultImage || '';
    },
    getInitialState: function () {
        return { url: this._urlForState(this.props) };
    },
    componentWillReceiveProps: function (nextProps) {
        this.setState({ url: this._urlForState(nextProps) });
    },
    onUploadComplete: function (info) {
        this.setState({ url: info.cdnUrl });
        this.props.onChange(info.cdnUrl);
    },
    componentDidMount: function () {
        this.widget = window.uploadcare.Widget(this.refs.input.getDOMNode());
        this.widget.onUploadComplete(this.onUploadComplete);
    },
    previewUrl: function () {
        var isUC = this.state.url.indexOf('ucarecdn');
        return isUC > -1 ? this.state.url + '-/preview/200x200/' : this.state.url;
    },
    render: function () {
        var imgSrc = this.previewUrl();
        return (
            <div className="image-uploader">
            {imgSrc.length > 0 && <img src={imgSrc} />}

            <input ref="input" type="hidden" data-images-only="true" />
        </div>
        );
    }
});
module.exports = ImageUploader;
