var _ = require('underscore');
var React = require('react');
var WysiHTMLEditor = require('elements/WysiHtmlEditor');
var {i18n, I18N} = require('I18N');
var RichTextEditor = React.createClass({
    propTypes: {
        value: React.PropTypes.string.isRequired,
        onChange: React.PropTypes.func.isRequired,
        wysihtml5Configuration: React.PropTypes.object.isRequired,
        editorStylesheetUrl: React.PropTypes.string.isRequired
    },
    componentDidMount: function () {
        this.wysihtml5 = this.refs.editor._rte;
        this.wysihtml5.on('change', this.textDidChange);
        this.wysihtml5.on('blur', this.textDidChange);
        this.wysihtml5.on('newword:composer', this.textDidChange);
    },
    textDidChange: function () {
        this.wysihtml5.composer.selection.editor.synchronizer.fromComposerToTextarea(true);
        this.props.onChange(this.refs.editor.getDOMNode().value);
    },
    getInitialState: function () {
        return { toolbarId: _.uniqueId('abc-rte-toolbar-') };
    },
    wysihtml5Configuration: function () {
        return this.props.wysihtml5Configuration;
    },
    stylesheetUrl: function () {
        return this.props.editorStylesheetUrl;
    },
    renderToolbar: function () {
        var self = this;
        return this.wysihtml5Configuration().toolbar.map(function (item) {
            return (
                <a
                    data-wysihtml5-command={item.command}
                    key={item.command}
                    title={item.title}
                    href="#" tabIndex="-1">
                <i className={item.icon_class}></i>
            </a>
            );
        });
    },
    render: function () {
        return (
            <div>
            <div className="rte-container">
                <div className="toolbar" id={this.state.toolbarId} style={{ display: 'none' }}>
                    {this.renderToolbar()}

                    {}
                    <div data-wysihtml5-dialog="createLink" className="create-link-dialog" style={{ display: 'none' }}>
                        <label><I18N
                                    message={'Link:'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>Link:</span>;
                                    }} />
                            <input data-wysihtml5-dialog-field="href" defaultValue="http://" />
                        </label>
                        <label><I18N
                                    message={'Text:'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>Text:</span>;
                                    }} />
                            <input data-wysihtml5-dialog-field="text" />
                        </label>
                        <input type="hidden" data-wysihtml5-dialog-field="rel" defaultValue="nofollow" />
                        <input type="hidden" data-wysihtml5-dialog-field="target" value="_blank" />
                        <div className="dialog-buttons">
                            <button data-wysihtml5-dialog-action="save"><I18N
                                        message={'OK'}
                                        context={this}
                                        args={[]}
                                        fallback={function () {
                                            return <span>OK</span>;
                                        }} /></button>
                            <button data-wysihtml5-dialog-action="cancel" className="cancel"><I18N
                                        message={'Cancel'}
                                        context={this}
                                        args={[]}
                                        fallback={function () {
                                            return <span>Cancel</span>;
                                        }} /></button>
                        </div>
                    </div>

                    {}
                    <div data-wysihtml5-dialog="editImage" className="edit-image-dialog" style={{ display: 'none' }}>
                        <label><I18N
                                    message={'Width:'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>Width:</span>;
                                    }} />
                            <input data-wysihtml5-dialog-field="width" className="short-input" />
                        </label>
                        <label><I18N
                                    message={'Height:'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>Height:</span>;
                                    }} />
                            <input data-wysihtml5-dialog-field="height" className="short-input" />
                        </label>
                        <label><I18N
                                    message={'Caption:'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>Caption:</span>;
                                    }} />
                            <input data-wysihtml5-dialog-field="caption" />
                        </label>
                        <label><I18N
                                    message={'Link:'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>Link:</span>;
                                    }} />
                            <input data-wysihtml5-dialog-field="href" />
                        </label>
                        <input type="hidden" data-wysihtml5-dialog-field="rel" defaultValue="nofollow" />
                        <input type="hidden" data-wysihtml5-dialog-field="target" value="_blank" />
                        <div className="dialog-buttons">
                            <button data-wysihtml5-dialog-action="save"><I18N
                                        message={'OK'}
                                        context={this}
                                        args={[]}
                                        fallback={function () {
                                            return <span>OK</span>;
                                        }} /></button>
                            <button data-wysihtml5-dialog-action="cancel" className="cancel"><I18N
                                        message={'Cancel'}
                                        context={this}
                                        args={[]}
                                        fallback={function () {
                                            return <span>Cancel</span>;
                                        }} /></button>
                        </div>
                    </div>

                    {}
                    <div className="uploadcare-button-container">
                        <button className="custom-uploadcare-widget-button" data-resize-image="undo"><I18N
                                    message={'Undo'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>Undo</span>;
                                    }} /></button>
                        <button className="custom-uploadcare-widget-button" data-resize-image="complete"><I18N
                                    message={'Complete'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>Complete</span>;
                                    }} /></button>
                        <div className="uploadcare-dialog-title"><I18N
                                    message={'Resize Image'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>Resize Image</span>;
                                    }} /></div>
                    </div>

                    {}
                    <div data-wysihtml5-dialog="embedYoutube" className="add-video-dialog" style={{ display: 'none' }}>
                        <label><I18N
                                    message={'URL:'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>URL:</span>;
                                    }} />
                            <input data-wysihtml5-dialog-field="src" />
                        </label>
                        <label><I18N
                                    message={'Width:'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>Width:</span>;
                                    }} />
                            <input data-wysihtml5-dialog-field="width" />
                        </label>
                        <div className="dialog-buttons">
                            <button data-wysihtml5-dialog-action="save"><I18N
                                        message={'OK'}
                                        context={this}
                                        args={[]}
                                        fallback={function () {
                                            return <span>OK</span>;
                                        }} /></button>
                            <button data-wysihtml5-dialog-action="cancel" className="cancel">{i18n('Cancel')}</button>
                        </div>
                    </div>
                </div>

                <WysiHTMLEditor ref="editor"
                        value={this.props.value}
                        onChange={function () {
                        }}
                        toolbarId={this.state.toolbarId}
                        parserRules={JSON.stringify(this.wysihtml5Configuration())}
                        stylesheetUrl={this.stylesheetUrl()} />
            </div>
        </div>
        );
    }
});
module.exports = RichTextEditor;
