var TokenEditor = React.createClass({
    propTypes: {
        name: React.PropTypes.string.isRequired,
        disabled: React.PropTypes.bool,
        prompt: React.PropTypes.string,
        placeholder: React.PropTypes.string,
        tokens: React.PropTypes.arrayOf(React.PropTypes.string).isRequired,
        onChange: React.PropTypes.func.isRequired
    },
    getDefaultProps: function () {
        return { prompt: '' };
    },
    render: function () {
        return (
            <div className={this.props.className}>
                <ABC.If test={this.props.prompt.length > 0}>
                    <label>{this.props.prompt}</label>
                </ABC.If>
                <TokenField
                    name={this.props.name}
                    tokens={this.props.tokens}
                    onChange={this.props.onChange}
                    disabled={this.props.disabled}
                    placeholder={this.props.placeholder} />
                <TokenList
                    tokens={this.props.tokens}
                    name={this.props.name}
                    onChange={this.props.onChange}
                    disabled={this.props.disabled} />
            </div>
        );
    }
});
var TokenField = React.createClass({
    render: function () {
        return (
            <input ref="input"
                name={this.props.name}
                placeholder={this.props.placeholder}
                onKeyDown={this.addToken}
                disabled={this.props.disabled} />
        );
    },
    addToken: function (event) {
        if (event.key == 'Enter') {
            event.preventDefault();
            var val = event.target.value.replace(/^\s+|\s+$/g, '').replace(/\s+/g, ' '), tokens = this.props.tokens;
            if (val && tokens.indexOf(val) == -1) {
                tokens = tokens.concat(val);
            }
            event.target.value = '';
            this.props.onChange(tokens);
        }
    }
});
var TokenList = React.createClass({
    render: function () {
        return (
            <ul>
            {this.renderItems(this.props.tokens)}
        </ul>
        );
    },
    renderItems: function (tokens) {
        return tokens.map(function (token) {
            return <li key={token} data-token-item={token} onClick={this.removeToken}>{token}</li>;
        }.bind(this));
    },
    removeToken: function (evt) {
        if (!this.props.disabled) {
            this.props.onChange(_.without(this.props.tokens, evt.target.getAttribute('data-token-item')));
        }
    }
});
module.exports = TokenEditor;
