'use strict';
var Immutable = require('immutable');
var Client = {
    setDimensions(world, dims) {
        world.performAction({
            name: 'Client/SetDimensions',
            transaction: ws => ws.setIn([
                'Client',
                'Dimensions'
            ], Immutable.Map(dims))
        });
    },
    getDimensions(world) {
        return world.getIn([
            'Client',
            'Dimensions'
        ]);
    },
    isMobile(world, threshold) {
        var dimensions = this.getDimensions(world);
        threshold = threshold || 768;
        return dimensions ? dimensions.get('width') < threshold : undefined;
    }
};
module.exports = Client;
