var _ = require('underscore');
var Actions = require('Actions');
var Client = require('dealers/Client');
var afterClosePath = [
    'LoginSignup',
    'afterClose'
];
var signupPath = [
    'LoginSignup',
    'isOpen'
];
module.exports = {
    openSignup(world, afterCloseAction) {
        world.performAction({
            name: 'LoginSignup/openSignup',
            transaction: ws => ws.setIn(signupPath, true).setIn(afterClosePath, afterCloseAction),
            effect: world => {
                if (Client.isMobile(world)) {
                    _.defer(() => document.querySelector('footer .signup-flow').scrollIntoView());
                }
            }
        });
    },
    closeSignup(world) {
        var afterCloseAction = this.afterCloseAction(world);
        if (afterCloseAction) {
            world.performAction(afterCloseAction);
        }
        world.performAction({
            name: 'LoginSignup/closeSignup',
            transaction: ws => ws.setIn(signupPath, false).removeIn(afterClosePath),
            effect: world => {
                if (Client.isMobile(world)) {
                    window.scrollTo(0, 0);
                }
            }
        });
    },
    isSignupOpen(world) {
        return world.getIn(signupPath);
    },
    isModalSignupOpen(world) {
        return !Client.isMobile(world) && this.isSignupOpen(world);
    },
    isFooterSignupOpen(world) {
        return Client.isMobile(world) && this.isSignupOpen(world);
    },
    afterCloseAction(world) {
        var action = world.getIn(afterClosePath);
        return Actions.construct(action);
    }
};
