module.exports = {
    isMobileNavMenuOpen(world) {
        return world.getIn([
            'NavMenu',
            'MobileNavMenuShown'
        ]);
    },
    toggleMobileNavMenu(world, state) {
        state = state === undefined ? !this.isMobileNavMenuOpen(world) : state;
        world.performAction({
            name: 'NavMenu/ToggleMobileNavMenu',
            transaction: ws => ws.setIn([
                'NavMenu',
                'MobileNavMenuShown'
            ], state)
        });
    },
    isApplicationSliding(world) {
        return world.getIn([
            'NavMenu',
            'ApplicationSliding'
        ]);
    },
    toggleApplicationSlide(world, state) {
        state = state === undefined ? !this.isMobileNavMenuOpen(world) : state;
        world.performAction({
            name: 'NavMenu/ToggleApplicationSlide',
            transaction: ws => ws.setIn([
                'NavMenu',
                'ApplicationSliding'
            ], state)
        });
    },
    slidingClassNames(world, openIfSliding) {
        var open = this.isMobileNavMenuOpen(world);
        var sliding = this.isApplicationSliding(world);
        return {
            open: open || (openIfSliding ? sliding : false),
            close: !open && sliding,
            slide: true
        };
    }
};
