'use strict';
var React = require('react');
var Client = require('dealers/Client');
var ResizeWatcher = require('elements/ResizeWatcher');
var Worldly = require('Worldly');
var Centered = React.createClass({
    mixins: [Worldly],
    getInitialState: function () {
        return {
            top: this.props.initialY || 0,
            left: this.props.initialX || 0,
            height: 0,
            width: 0,
            computed: false
        };
    },
    componentDidMount: function () {
        this.prevHeight = this.getDOMNode().scrollHeight;
    },
    prevHeight: 0,
    componentDidUpdate: function (prevProps, prevState) {
        this.prevHeight = prevState.height;
    },
    computeCenteredDims: function (dims) {
        var node = this.getDOMNode();
        this.setState({
            top: Math.max((dims.height - node.scrollHeight) / 2, 0),
            left: Math.max((dims.width - node.scrollWidth) / 2, 0),
            height: Math.min(dims.height, node.scrollHeight),
            width: Math.min(dims.width, node.scrollWidth),
            computed: true
        });
    },
    render: function () {
        var styles = {
            position: 'absolute',
            top: this.state.top,
            left: this.state.left,
            height: this.state.height,
            width: this.state.width,
            opacity: this.state.computed ? 1 : 0,
            transitionProperty: 'opacity',
            transitionDuration: '.3s',
            transitionEasing: 'ease-out'
        };
        return (
            <div className="centered" style={styles}>
            {this.props.children}
            <ResizeWatcher onResize={this.computeCenteredDims} />
        </div>
        );
    }
});
module.exports = Centered;
