'use strict';
var React = require('react');
var {I18N, i18n} = require('I18N');
var Error = React.createClass({
    render: function () {
        return (
            <div className="susify error">
                <h1>{this.props.headline}</h1>
                {this.props.children}
            </div>
        );
    }
});
var Unauthorized = React.createClass({
    render: function () {
        return (
            <Error headline={i18n('Come on in!')}>
                <p><I18N
                        message={'Thanks for being here. You\'ll need to <a:login href="#">log in</a:login> or <a:signup href="#">sign up</a:signup> to see this page.'}
                        context={this}
                        args={[]}
                        fallback={function () {
                            return <span>Thanks for being here. You&apos;ll need to <a href="#" onClick={this.popLogIn}>log in</a> or <a href="#" onClick={this.popLogIn}>sign up</a> to see this page.</span>;
                        }} />
                </p>
            </Error>
        );
    },
    popLogIn: function (event) {
        event.preventDefault();
        FormSherpa.present('ido-signup', $('[data-role=modal]'), { modal: true });
    }
});
var Forbidden = React.createClass({
    render: function () {
        return (
            <Error headline={i18n('Uh oh!')}>
              <I18N
                    message={'<p>Sorry we can&apos;t show you this page right now. It may have expired or you may not have permission to view it.</p>\n              <p>Would you like to <a:back href="#">go back</a:back> or <a:home href="/">home</a:home> instead?</p>'}
                    context={this}
                    args={[]}
                    fallback={function () {
                        return (
                            <span><p>Sorry we can&apos;t show you this page right now. It may have expired or you may not have permission to view it.</p>
              <p>Would you like to <a href="#" onClick={this.goBack}>go back</a> or <a href="/">home</a> instead?</p></span>
                        );
                    }} />
            </Error>
        );
    },
    goBack: function (event) {
        event.preventDefault();
        window.history.go(-1);
    }
});
var NotFound = React.createClass({
    render: function () {
        return (
            <Error headline={i18n('Oops! Resource not found')}>
                <p><I18N
                        message={'Nothing is here right now.'}
                        context={this}
                        args={[]}
                        fallback={function () {
                            return <span>Nothing is here right now.</span>;
                        }} /></p>
            </Error>
        );
    }
});
var UnexpectedError = React.createClass({
    render: function () {
        return (
            <Error headline={i18n('An unexpected error occurred')}>
                <I18N
                    message={'<p>Well, this is embarrassing.</p>\n                <p>Error code: {this.props.error.status}</p>'}
                    context={this}
                    args={[]}
                    fallback={function () {
                        return (
                            <span><p>Well, this is embarrassing.</p>
                <p>Error code: {this.props.error.status}</p></span>
                        );
                    }} />
            </Error>
        );
    }
});
function standardHandler(error) {
    error = error.toJS();
    switch (error.status) {
    case 401:
        return <Unauthorized />;
        break;
    case 403:
        return <Forbidden />;
        break;
    case 404:
        return <NotFound />;
        break;
    default:
        return <UnexpectedError error={error} />;
    }
}
module.exports = {
    Error: Error,
    Unauthorized: Unauthorized,
    Forbidden: Forbidden,
    standardHandler: standardHandler
};
