'use strict';
var React = require('react');
var Assets = require('dealers/Assets');
var Wish = require('Wish');
var Worldly = require('Worldly');
var {I18N, i18n} = require('I18N');
var Look = require('elements/Look');
var PageActions = React.createClass({
    render: function () {
        var actions = this.props.actions;
        return (
            <ul className="pageActions">
            <li>
                <button
                        onClick={function () {
                            location.href = actions.rsvp.url;
                        }}>
                    {actions.rsvp.is_attending ? i18n('Attending') : i18n('RSVP')}
                </button>
            </li>
            <li>
                <button
                        onClick={function () {
                            location.href = actions.bookmark.url;
                        }}>
                    {actions.bookmark.bookmarked ? i18n('Un-Bookmark') : i18n('Bookmark')}
                </button>
            </li>
            <li>
                <button
                        onClick={function () {
                            location.href += '#spread-the-word';
                        }}>
                    <I18N
                            message={'Spread the word'}
                            context={this}
                            args={[]}
                            fallback={function () {
                                return <span>Spread the word</span>;
                            }} />
                </button>
            </li>
            <li>
                <button
                        onClick={function () {
                            print();
                        }}>
                    <I18N
                            message={'Print'}
                            context={this}
                            args={[]}
                            fallback={function () {
                                return <span>Print</span>;
                            }} />
                </button>
            </li>
        </ul>
        );
    }
});
var GradFairHeader = React.createClass({
    mixins: [Worldly],
    render: function () {
        var doc = this.props.fair;
        var location = '';
        if (doc.addresses && doc.addresses[0]) {
            location = doc.addresses[0].city;
        }
        var actions = Assets.actionsForAsset(this.world(), doc.external_id);
        return (
            <header id="contentHeader">
            <h1><I18N
                        message={'{location} Idealist Grad Fair'}
                        context={this}
                        args={[location]}
                        fallback={function () {
                            return <span>{location} Idealist Grad Fair</span>;
                        }} /></h1>
            <Look wish={actions}>{{
                        Pending: function () {
                            return <PageActions actions={doc.actions} />;
                        },
                        Available: function (actions) {
                            return <PageActions actions={actions.toJS()} />;
                        },
                        Error: function () {
                            return <div>ERROR: page actions not available</div>;
                        }
                    }}</Look>
        </header>
        );
    }
});
module.exports = GradFairHeader;
