'use strict';
var React = require('react/addons');
var {I18N, i18n} = require('I18N');
var Signin = require('dealers/Signin');
var FormInput = require('elements/FormInput');
var LocationField = require('elements/LocationField');
var NameLocInlineJanrainView = React.createClass({
    render: function () {
        return (
            <div>
            <div className="create-account">
                <div className="field">
                    <label><I18N
                                message={'Email'}
                                context={this}
                                args={[]}
                                fallback={function () {
                                    return <span>Email</span>;
                                }} /></label>
                    <FormInput type="text" ref="email" name="email"
                            value={this.props.email}
                            onChange={Signin.changeHandlerFor('email')}
                            disabled={true}
                            onFocus={this.props.hideFieldValidation('email')}
                            validation={this.props.emailValidation} />
                </div>
                <div className="field">
                    <label><I18N
                                message={'Location'}
                                context={this}
                                args={[]}
                                fallback={function () {
                                    return <span>Location</span>;
                                }} /></label>
                    <LocationField
                            value={this.props.location}
                            autocompleteEndpointOptions={{ type: 'place' }}
                            onChange={this.props.changeLocation}
                            onFocus={this.props.hideFieldValidation('location')}
                            validation={this.props.locationValidation} />
                </div>
            </div>
            <div className="social-log-in">
                <div className="field">
                    <label><I18N
                                message={'Full Name'}
                                context={this}
                                args={[]}
                                fallback={function () {
                                    return <span>Full Name</span>;
                                }} /></label>
                    <FormInput type="text" ref="full_name" name="full_name"
                            value={this.props.fullName}
                            placeholder={i18n('Enter your full name')}
                            onChange={Signin.changeHandlerFor('full_name')}
                            onFocus={this.props.hideFieldValidation('full_name')}
                            validation={this.props.fullNameValidation} />
                </div>
                <div className="field">
                    <label><I18N
                                message={'What should we call you?'}
                                context={this}
                                args={[]}
                                fallback={function () {
                                    return <span>What should we call you?</span>;
                                }} /></label>
                    <FormInput type="text" ref="first_name" name="first_name"
                            value={this.props.firstName}
                            placeholder={i18n('e.g. first name or nickname')}
                            onChange={Signin.changeHandlerFor('first_name')}
                            onFocus={this.props.hideFieldValidation('first_name')}
                            validation={this.props.firstNameValidation} />
                </div>
            </div>
        </div>
        );
    },
    isValid() {
        return true;
    }
});
module.exports = NameLocInlineJanrainView;
