'use strict';
var React = require('react');
var Worldly = require('Worldly');
var Spinner = require('elements/Spinner');
var Look = React.createClass({
    mixins: [Worldly],
    propTypes: {
        wish: React.PropTypes.object,
        path: React.PropTypes.arrayOf(React.PropTypes.string),
        children: React.PropTypes.shape({
            Pending: React.PropTypes.func,
            Available: React.PropTypes.func,
            Error: React.PropTypes.func
        }).isRequired
    },
    render: function () {
        var path, wish;
        if (typeof this.props.wish !== 'undefined') {
            wish = this.props.wish;
        } else if (typeof this.props.path !== 'undefined') {
            path = this.props.path.toJS ? this.props.path.toJS() : this.props.path;
            wish = this.world().getIn(path);
        } else {
            throw new Error('<Look> received neither wish nor path');
        }
        var state = wish.get('state');
        var value = wish.get('value');
        return this.props.children[state].call(null, value);
    }
});
Look.Quick = React.createClass({
    propTypes: {
        wish: React.PropTypes.object,
        path: React.PropTypes.arrayOf(React.PropTypes.string),
        children: React.PropTypes.func.isRequired
    },
    render() {
        return (
            <Look {...this.props}>
            {{
                    Available: this.props.children || (() => null),
                    Pending: () => <Spinner />,
                    Error: () => null
                }}
        </Look>
        );
    }
});
module.exports = Look;
