var React = require('react');
import {
    i18n,
    I18N
} from 'I18N';
import { Validation } from 'conformist';
var Field = require('elements/Forms/Field');
var InputWrapper = require('elements/Forms/InputWrapper');
var TransitionGroup = React.addons.CSSTransitionGroup;
var OrgValidationMessage = React.createClass({
    render() {
        return (
            <div
                className={[
                    'error-slot',
                    this.props.externalWidget ? 'external-widget-cushion' : null
                ].join(' ')}>
            <TransitionGroup transitionName="input-error" transitionAppear={true}>
                {this.props.messages.length && (
                        <div key="error" className="error-slider">
                    <div className="error-balloon">{this.props.messages.map(m => <div key={m}>{m}</div>)}</div>
                </div>
                    )}
            </TransitionGroup>
        </div>
        );
    }
});
var OrgField = React.createClass({
    mixins: [Field],
    propTypes: {
        label: React.PropTypes.string,
        help: React.PropTypes.string,
        type: React.PropTypes.oneOfType([
            React.PropTypes.func,
            React.PropTypes.string
        ]),
        className: React.PropTypes.string,
        disabled: React.PropTypes.bool,
        showErrors: React.PropTypes.bool
    },
    render() {
        var element = this.schemaElement();
        var errors = element.errors;
        var {
            type,
            label,
            help,
            className,
            required,
            showErrors,
            ...props
        } = this.props;
        var Input;
        if (typeof type === 'function') {
            Input = type;
        } else {
            Input = InputWrapper;
        }
        return (
            <div style={{ position: 'relative' }} className={this.props.className || ''}>
            <p className="hint">{this.props.help}</p>
            <label>
                {label || props.name}
                {(required || element.hasValidator(Validation.Value.Present)) && (
                        <I18N
                            message={'<span:required>(Required)</span:required>'}
                            context={this}
                            args={[]}
                            fallback={function () {
                                return <span><span className="required">(Required)</span></span>;
                            }} />
                    )}
            </label>
            <Input
                    type={type}
                    onChange={this.onChange}
                    value={element.value}
                    showErrors={showErrors} {...props} />
            {showErrors && <OrgValidationMessage externalWidget={props.externalWidget} messages={element.errors} />}
        </div>
        );
    }
});
module.exports = OrgField;
