'use strict';
var React = require('react/addons');
var _ = require('underscore');
var classNames = require('classnames');
var LoginSignup = require('dealers/LoginSignup');
var NavMenu = require('dealers/NavMenu');
var Worldly = require('Worldly');
var {I18N, i18n} = require('I18N');
var Feature = require('elements/Feature');
var Link = require('elements/Link');
var SignupFlow = require('elements/LoginSignup/SignupFlow');
var PageHeaderAssetSearches = require('./PageHeaderAssetSearches');
var Search = require('./PageHeaderSearch');
var PageFooter = React.createClass({
    mixins: [Worldly],
    helpPath: function () {
        return 'Help';
    },
    render: function () {
        var currentYear = new Date().getFullYear();
        return (
            <footer id="footer" className={classNames('ido-footer', NavMenu.slidingClassNames(this.world()))} role="contentinfo">
            <div className="search-n-assets">
               <Search.PageFooterSearch />

               <div className="brand">
                  <div className="verticalize">
                    <img src="/images/logos/idealist_120.png" width="60" alt="Idealist.org" />
                  </div>
               </div>

               <h2 className="tagline"><I18N
                            message={'We connect idealists with opportunities for action.'}
                            context={this}
                            args={[]}
                            fallback={function () {
                                return <span>We connect idealists with opportunities for action.</span>;
                            }} /></h2>
               <PageHeaderAssetSearches />
            </div>

            {LoginSignup.isFooterSignupOpen(this.world()) ? (
                    <SignupFlow
                        onClose={e => {
                            LoginSignup.closeSignup(this.world());
                        }} />
                ) : null}

            <div className="susify">
                {}
                <div className="brand">
                    <div className="verticalize">
                        <img src="http://www.idealist.org/images/logos/idealist_120.png" width="60" alt="FIXME ALT" />
                    </div>
                </div>

                {}
                <div className="social-links">
                    <div className="verticalize">
                        <ul>
                            <li>
                                <a id="linkedin" href="http://www.linkedin.com/groups?gid=1138797"><i className="social linkedin"></i><I18N
                                            message={'linkedin'}
                                            context={this}
                                            args={[]}
                                            fallback={function () {
                                                return <span>linkedin</span>;
                                            }} /></a>
                            </li>
                            <li>
                                <a id="twitter" href="http://twitter.com/idealist"><i className="social twitter"></i><I18N
                                            message={'twitter'}
                                            context={this}
                                            args={[]}
                                            fallback={function () {
                                                return <span>twitter</span>;
                                            }} /></a>
                            </li>
                            <li>
                                <a id="facebook" href="http://www.facebook.com/Idealist"><i className="social facebook"></i><I18N
                                            message={'facebook'}
                                            context={this}
                                            args={[]}
                                            fallback={function () {
                                                return <span>facebook</span>;
                                            }} /></a>
                            </li>
                            <li className="youtube">
                                <a id="youtube" href="http://www.youtube.com/idealist"><i className="social youtube"></i><I18N
                                            message={'youtube'}
                                            context={this}
                                            args={[]}
                                            fallback={function () {
                                                return <span>youtube</span>;
                                            }} /></a>
                            </li>
                        </ul>
                    </div>
                </div>

                {}
                <div className="links-n-legal">
                    <div className="verticalize">
                        <div className="stack">
                            <nav className="footer-links">
                                <ul>
                                    <li>
                                        <Link endpoint='about-us'><I18N
                                                    message={'About'}
                                                    context={this}
                                                    args={[]}
                                                    fallback={function () {
                                                        return <span>About</span>;
                                                    }} /></Link>
                                    </li>
                                    <li>
                                        <Link endpoint='info/view-path' values={{ path: 'About/Vision' }}><I18N
                                                    message={'Vision'}
                                                    context={this}
                                                    args={[]}
                                                    fallback={function () {
                                                        return <span>Vision</span>;
                                                    }} /></Link>
                                    </li>
                                    <li>
                                        <Feature name="our-team">
                                            <Feature.Enabled>
                                                <Link endpoint='our-team'><I18N
                                                            message={'Our Team'}
                                                            context={this}
                                                            args={[]}
                                                            fallback={function () {
                                                                return <span>Our Team</span>;
                                                            }} /></Link>
                                            </Feature.Enabled>
                                            <Feature.Disabled>
                                                <Link endpoint='info/view-path' values={{ path: 'About/Staff' }}><I18N
                                                            message={'Our Team'}
                                                            context={this}
                                                            args={[]}
                                                            fallback={function () {
                                                                return <span>Our Team</span>;
                                                            }} /></Link>                                                
                                            </Feature.Disabled>
                                        </Feature>
                                    </li>
                                    <li>
                                        <Link endpoint='working-here'><I18N
                                                    message={'Working Here'}
                                                    context={this}
                                                    args={[]}
                                                    fallback={function () {
                                                        return <span>Working Here</span>;
                                                    }} /></Link>
                                    </li>
                                    <li>
                                        <Link endpoint='info/view-path' values={{ path: 'About/Content/Blogs' }}><I18N
                                                    message={'Blogs'}
                                                    context={this}
                                                    args={[]}
                                                    fallback={function () {
                                                        return <span>Blogs</span>;
                                                    }} /></Link>
                                    </li>
                                    <li>
                                        <Link endpoint='info/view-path' values={{ path: 'GradFairs' }}><I18N
                                                    message={'Grad Fairs'}
                                                    context={this}
                                                    args={[]}
                                                    fallback={function () {
                                                        return <span>Grad Fairs</span>;
                                                    }} /></Link>
                                    </li>
                                    <li>
                                        <Link endpoint='info/view-path' values={{ path: this.helpPath() }}><I18N
                                                    message={'Help'}
                                                    context={this}
                                                    args={[]}
                                                    fallback={function () {
                                                        return <span>Help</span>;
                                                    }} /></Link>
                                    </li>
                                    <li>
                                        <Link endpoint="contact-us"><I18N
                                                    message={'Contact us'}
                                                    context={this}
                                                    args={[]}
                                                    fallback={function () {
                                                        return <span>Contact us</span>;
                                                    }} /></Link>
                                    </li>
                                    <li>
                                        <Link endpoint="donate"><I18N
                                                    message={'Donate'}
                                                    context={this}
                                                    args={[]}
                                                    fallback={function () {
                                                        return <span>Donate</span>;
                                                    }} /></Link>
                                    </li>
                                </ul>
                            </nav>
                            <div className="legalese">
                                <nav className="legal">
                                    <ul>
                                        <li><Link endpoint='info/view-path' values={{ path: 'About/Terms' }}><I18N
                                                        message={'Terms & Conditions'}
                                                        context={this}
                                                        args={[]}
                                                        fallback={function () {
                                                            return <span>Terms &amp; Conditions</span>;
                                                        }} /></Link></li>
                                        <li><Link endpoint='info/view-path' values={{ path: 'About/Privacy' }}><I18N
                                                        message={'Privacy Policy'}
                                                        context={this}
                                                        args={[]}
                                                        fallback={function () {
                                                            return <span>Privacy Policy</span>;
                                                        }} /></Link></li>
                                        <li><Link endpoint='info/view-path' values={{ path: 'Help/Guidelines' }}><I18N
                                                        message={'Community Guidelines'}
                                                        context={this}
                                                        args={[]}
                                                        fallback={function () {
                                                            return <span>Community Guidelines</span>;
                                                        }} /></Link></li>
                                    </ul>
                                </nav>
                                <span className="copyright"><I18N
                                            message={'\xA91995-{currentYear}, Action Without Borders\n                                    <span:mobile-hide>\u2014 a 501(c)3 non-profit organization.</span:mobile-hide>'}
                                            context={this}
                                            args={[currentYear]}
                                            fallback={function () {
                                                return (
                                                    <span>
                                    ©1995-{currentYear}, Action Without Borders
                                    <span className="mobile-hide">— a 501(c)3 non-profit organization.</span>
                                </span>
                                                );
                                            }} /></span>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </footer>
        );
    }
});
module.exports = PageFooter;
