'use strict';
var React = require('react/addons');
var Link = require('elements/Link');
var {I18N, i18n} = require('I18N');
function capitalize(str) {
    return str.charAt(0).toUpperCase() + str.slice(1);
}
var AssetSearch = React.createClass({
    render: function () {
        var className = 'searchLinkForAssetType' + capitalize(this.props.type);
        return (
            <Link endpoint="search"
                values={{
                    search_type: this.props.type,
                    csrc: 'header'
                }} className={className}>
            {this.props.children}
        </Link>
        );
    }
});
var PageHeaderAssetSearches = React.createClass({
    render: function () {
        return (
            <div className="assetSearches">
            <span className="group">
                <AssetSearch type="job"><I18N
                            message={'Jobs'}
                            context={this}
                            args={[]}
                            fallback={function () {
                                return <span>Jobs</span>;
                            }} /></AssetSearch>
                <AssetSearch type="internship"><I18N
                            message={'Internships'}
                            context={this}
                            args={[]}
                            fallback={function () {
                                return <span>Internships</span>;
                            }} /></AssetSearch>
            </span>
            <span className="group">
                <AssetSearch type="volop"><I18N
                            message={'Volunteer'}
                            context={this}
                            args={[]}
                            fallback={function () {
                                return <span>Volunteer</span>;
                            }} /></AssetSearch>
                <Link endpoint="act" className="action"><I18N
                            message={'Action'}
                            context={this}
                            args={[]}
                            fallback={function () {
                                return <span>Action</span>;
                            }} /></Link>
                <AssetSearch type="event"><I18N
                            message={'Events'}
                            context={this}
                            args={[]}
                            fallback={function () {
                                return <span>Events</span>;
                            }} /></AssetSearch>
            </span>
            <span className="group">
                <AssetSearch type="org"><I18N
                            message={'Organizations'}
                            context={this}
                            args={[]}
                            fallback={function () {
                                return <span>Organizations</span>;
                            }} /></AssetSearch>
            </span>
        </div>
        );
    }
});
module.exports = PageHeaderAssetSearches;
