'use strict';
var React = require('react/addons');
var LoginSignup = require('dealers/LoginSignup');
var Router = require('Router');
var Worldly = require('Worldly');
var {I18N, i18n} = require('I18N');
var If = require('abc/if');
var LocationField = require('elements/LocationField');
var PopupMenu = require('abc/popup_menu');
var Input = require('react-placeholder-shim/react-placeholder-shim.jsx').Input;
var PageHeaderSearch = React.createClass({
    mixins: [Worldly],
    getInitialState: function () {
        return { lastLocationResult: '' };
    },
    openSignup: function () {
        LoginSignup.openSignup(this.world());
    },
    render: function () {
        var actionUrl = Router.urlForRoute(Router.route('search'));
        var isStaff = false;
        var thisJustSaysOr = ' ' + i18n('or') + ' ';
        return (
            <div id="searchBox" className={isStaff ? 'staff' : ''} role="search">
            <form name="search_form"
                    action={actionUrl} method="post"
                    className="site-search">
                <input type="hidden" id="search_qs" name="qs" />
                <input type="hidden" id="search_language" name="search_language"
                        value="en" />
                <input type="hidden" id="search_location_language" name="search_location_language"
                        value="en" />
                <If test={isStaff}>
                    <input type="hidden" id="search_staff" name="search_staff"
                            value={true} />
                </If>
                <div className="styled-select" tabIndex="2">
                    <select name="search_type" id="searchOptions">
                        <option value=""><I18N
                                    message={'All types'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>All types</span>;
                                    }} /></option>
                        <option value="job"><I18N
                                    message={'Jobs'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>Jobs</span>;
                                    }} /></option>
                        <option value="internship"><I18N
                                    message={'Internships'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>Internships</span>;
                                    }} /></option>
                        <option value="volop"><I18N
                                    message={'Volunteer Opps'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>Volunteer Opps</span>;
                                    }} /></option>
                        <option value="actionop"><I18N
                                    message={'Action Opps'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>Action Opps</span>;
                                    }} /></option>
                        <option value="user"><I18N
                                    message={'People'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>People</span>;
                                    }} /></option>
                        <option value="org"><I18N
                                    message={'Organizations'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>Organizations</span>;
                                    }} /></option>
                        <option value="event"><I18N
                                    message={'Events'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>Events</span>;
                                    }} /></option>
                        <option value="feature"><I18N
                                    message={'Blogs'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>Blogs</span>;
                                    }} /></option>
                    </select>
                </div>
                <Input name="search_user_query"
                        placeholder={i18n('What?')} type="text"
                        tabIndex="3" className="text" data-clearable="true" />

                <LocationField
                        placeholder={i18n('Where?')} tabIndex="4"
                        value={LocationField.blankLocation({ location: this.state.lastLocationResult })}
                        onChange={map => this.setState({ lastLocationResult: map.get('location') })}
                        onKeyUp={evt => this.setState({ lastLocationResult: evt.target.value })}
                        allowFallback={false} />
                  <input type="hidden" id="search_location_name" name="search_location_name"
                        value={this.state.lastLocationResult} />

                <div id="searchButtonContainer">
                    <div id="savedSearches" className="saved-searches delayedHover dropList" data-triggers-on="#ssExpando">
                        <div className="current">
                            <button type="submit" tabIndex="5" id="searchButton"
                                    className="button search left"><I18N
                                        message={'Search'}
                                        context={this}
                                        args={[]}
                                        fallback={function () {
                                            return <span>Search</span>;
                                        }} /></button>
                            <PopupMenu className="saved-search-menu"
                                    trigger={(
                                        <a href="" id="ssExpando" className="search button right">
                                            <span className="expando-arrow">&nbsp;</span>
                                        </a>
                                    )}>
                                <dl>
                                    <dt className="dropListItem anon">
                                        <I18N
                                                message={'Save your favorite searches.\n                                        <br />\n                                        <a:login href="#">Log in</a:login>\n                                        {thisJustSaysOr}\n                                        <a:signup href="#">sign up</a:signup>!'}
                                                context={this}
                                                args={[thisJustSaysOr]}
                                                fallback={function () {
                                                    return (
                                                        <span>Save your favorite searches.
                                        <br />
                                        <a href="#" onClick={this.openSignup}>Log in</a>
                                        {thisJustSaysOr}
                                        <a href="#" id="signup_link" onClick={this.openSignup}>sign up</a>!</span>
                                                    );
                                                }} />
                                    </dt>
                                </dl>
                                <a className="dropListItem advancedSearch" href="/search/v2/advanced"><I18N
                                            message={'Advanced search'}
                                            context={this}
                                            args={[]}
                                            fallback={function () {
                                                return <span>Advanced search</span>;
                                            }} /></a>
                            </PopupMenu>
                        </div>
                    </div>
                </div>
            </form>
        </div>
        );
    }
});
var PageFooterSearch = React.createClass({
    getInitialState: function () {
        return { lastLocationResult: '' };
    },
    render: function () {
        var actionUrl = Router.urlForRoute(Router.route('search'));
        var isStaff = false;
        return (
            <div id="footer-search" className={isStaff ? 'staff' : ''} role="search">
            <h1 className="search-message"><I18N
                        message={'Search Idealist'}
                        context={this}
                        args={[]}
                        fallback={function () {
                            return <span>Search Idealist</span>;
                        }} /></h1>
            <form name="search_form"
                    action={actionUrl} method="post"
                    className="main-site-search">
                <input type="hidden" id="search_qs" name="qs" />
                <input type="hidden" id="search_language" name="search_language"
                        value="en" />
                <input type="hidden" id="search_location_language" name="search_location_language"
                        value="en" />
                <If test={isStaff}>
                    <input type="hidden" id="search_staff" name="search_staff"
                            value={true} />
                </If>
                <div className="styled-select" tabIndex="2">
                    <select name="search_type" id="searchOptions">
                        <option value=""><I18N
                                    message={'All types'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>All types</span>;
                                    }} /></option>
                        <option value="job"><I18N
                                    message={'Jobs'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>Jobs</span>;
                                    }} /></option>
                        <option value="internship"><I18N
                                    message={'Internships'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>Internships</span>;
                                    }} /></option>
                        <option value="volop"><I18N
                                    message={'Volunteer Opps'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>Volunteer Opps</span>;
                                    }} /></option>
                        <option value="actionop"><I18N
                                    message={'Action Opps'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>Action Opps</span>;
                                    }} /></option>
                        <option value="user"><I18N
                                    message={'People'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>People</span>;
                                    }} /></option>
                        <option value="org"><I18N
                                    message={'Organizations'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>Organizations</span>;
                                    }} /></option>
                        <option value="event"><I18N
                                    message={'Events'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>Events</span>;
                                    }} /></option>
                        <option value="feature"><I18N
                                    message={'Blogs'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>Blogs</span>;
                                    }} /></option>
                    </select>
                </div>

                <input name="search_user_query"
                        placeholder={i18n('Keyword, skill, or interest')} type="text"
                        tabIndex="3" className="text search-user-query" />

                <LocationField
                        placeholder={i18n('Where?')} className="search-location-name"
                        value={LocationField.blankLocation({ location: this.state.lastLocationResult })}
                        onChange={map => this.setState({ lastLocationResult: map.get('location') })}
                        allowFallback={false} tabIndex="4" />
                  <input type="hidden" id="search_location_name" name="search_location_name"
                        value={this.state.lastLocationResult} />

                <button type="submit" tabIndex="5" className="search button"><I18N
                            message={'Search'}
                            context={this}
                            args={[]}
                            fallback={function () {
                                return <span>Search</span>;
                            }} /></button>
            </form>

            <hr id="footer-more" />
        </div>
        );
    }
});
module.exports = {
    PageHeaderSearch,
    PageFooterSearch
};
