'use strict';
var _ = require('underscore');
var React = require('react/addons');
var {i18n} = require('I18N');
var type = React.PropTypes;
var PaneFlow = React.createClass({
    propTypes: {
        flow: type.arrayOf(type.oneOfType([
            type.func,
            type.arrayOf(type.oneOfType([
                type.func,
                type.object
            ]))
        ])).isRequired,
        backButtonText: type.string,
        nextButtonText: type.string,
        currentPane: type.number.isRequired,
        onChangePane: type.func.isRequired,
        override: type.func
    },
    paneAtIndex: function (index) {
        var item = this.props.flow[index];
        return _.isArray(item) ? item[0] : item;
    },
    passedPaneProps: function (index) {
        var item = this.props.flow[index];
        return _.isArray(item) ? item[1] : {};
    },
    goBack: function () {
        this.props.onChangePane(this.index() - 1);
    },
    goNext: function () {
        this.props.onChangePane(this.index() + 1);
    },
    render: function () {
        var pane = this.props.override || this.paneAtIndex(this.index());
        var paneProps = {
            ...this.passedPaneProps(this.index()),
            ...this.props,
            atFlowStart: this.index() < 1,
            atFlowEnd: this.index() > this.props.flow.length - 2,
            goBack: this.goBack,
            goNext: this.goNext,
            ref: 'pane',
            valid: true
        };
        return React.createElement(pane, paneProps);
    },
    index: function () {
        return this.props.currentPane;
    },
    focus: function () {
        var pane = this.refs.pane;
        if (pane.focus) {
            pane.focus();
        }
    }
});
var PaneNavButtons = React.createClass({
    render: function () {
        return (
            <p className="actions">
            {this.props.atFlowStart ? '' : (
                    <a href="#" onClick={this.props.goBack} className='back'>
                    {this.props.backButtonText || i18n('\u2039\u2039 Back')}
                </a>
                )}

            {this.props.atFlowEnd ? '' : (
                    <button onClick={this.props.valid ? this.props.goNext : this.props.onInvalid} className={'next' + (this.props.valid ? '' : ' disabled')}>
                    {this.props.nextButtonText || i18n('Next \u203A\u203A')}
                </button>
                )}
        </p>
        );
    }
});
module.exports = {
    PaneFlow,
    PaneNavButtons
};
