var _ = require('underscore');
var Valid = require('abc/validators');
module.exports = {
    getInitialState() {
        if (!this.validators) {
            return;
        }
        return this._allValidationGates(false);
    },
    _allValidationGates(defaultVal) {
        var validationGates = {};
        for (var validatorName in this.validators) {
            validationGates[validatorName] = defaultVal;
        }
        return { validationGates };
    },
    _changeFieldValidation(fld, val) {
        return evt => {
            var newGates = _.clone(this.state.validationGates);
            newGates[fld] = val;
            this.setState({ validationGates: newGates });
        };
    },
    showFieldValidation(fld) {
        return this._changeFieldValidation(fld, true);
    },
    hideFieldValidation(fld) {
        return this._changeFieldValidation(fld, false);
    },
    showAllFieldValidation() {
        this.setState(this._allValidationGates(true));
    },
    hideAllFieldValidation() {
        this.setState(this._allValidationGates(false));
    },
    showValid: function (which) {
        return Valid.gated(this.state.validationGates[which], this.validators[which]());
    }
};
