var React = require('react/addons');
var TU = React.addons.TestUtils;
var ReactContext = require('react/lib/ReactContext');
var World = require('World');
module.exports = Object.assign({}, TU, {
    renderWithWorld(Component, props = {}, worldState = {}) {
        var world = this.world = new World(worldState);
        var SimEarth = React.createClass({
            childContextTypes: { IDO_i5_world_do_not_use_this: React.PropTypes.object.isRequired },
            componentDidMount() {
                world.onActionPerformed(this.forceUpdate.bind(this));
            },
            getChildContext() {
                return { IDO_i5_world_do_not_use_this: world };
            },
            render() {
                return (
                    <div>
                    <Component ref="component" {...props} />
                </div>
                );
            }
        });
        var simEarth = TU.renderIntoDocument(<SimEarth><Component ref="component" {...props} /></SimEarth>);
        return simEarth.refs.component;
    },
    renderShallowWithWorld(Component, props = {}, worldState = {}) {
        var world = this.world = new World(worldState);
        var renderer = TU.createRenderer();
        ReactContext.context = { IDO_i5_world_do_not_use_this: world };
        renderer.render(<Component {...props} />);
        ReactContext.context = {};
        return renderer.getRenderOutput();
    },
    scryRenderedDOMComponentsWithClassNames(tree, desiredClassNames) {
        return TU.findAllInRenderedTree(tree, component => hasClassNames(component, desiredClassNames));
    },
    findRenderedDOMComponentWithClassNames(tree, desiredClassNames) {
        var result = TU.findAllInRenderedTree(tree, component => hasClassNames(component, desiredClassNames));
        if (result.length !== 1) {
            throw new Error('Found ' + result.length + ' components with classNames ' + desiredClassNames);
        }
        return result[0];
    }
});
function hasClassNames(component, desiredClassNames) {
    var classNames = (component.props.className || '').split(/\s+/);
    return desiredClassNames.every(cn => classNames.indexOf(cn) !== -1);
}
