/*
 *
 *   Message Translation and Bundling
 *
 */


import ast from './ast';


const Translation = {
    translateMessagesToBundle(src, translations) {
        const bundle = {};

        const Plugin = function({Plugin, t}) {
            return new Plugin('bundling', {
                visitor: {
                    CallExpression(node, parent) {
                        if (node.callee.name === 'i18n') {
                            const message = node.arguments[0].value;
                            bundle[message] = translations[message];
                        }
                    },

                    JSXElement(node, parent) {
                        if (ast.isElementMarker(node)) {
                            const message = extraction.extractElementMessage(node);
                            const translationForMessage = translations[message];
                            const renderer = Translation.translatedRendererFor(node, translatedMessage);
                        }
                    }
                }
            });
        }

        babel.transform(src, {
            plugins: [plugin]
        });

        return bundle;
    },

    translatedRendererFor(markerNode, translatedMessage) {
        // build out mapping of unique/id'd components with sanitized attributes
        // parse translatedMessage
        // walk its ast and substitute sanitized messages where appropriate
        // determine free variables in markerNode
        // generate a render function with proper arguments and return
    }
};


export default Translation;
